package tauzaman.junit;

import static org.junit.Assert.*;

import org.junit.Test;

import tauzaman.extendedboolean.ExtendedBoolean;
import tauzaman.extendedboolean.ExtendedBoolean.LogicValue;

public class TestEB {
	@Test
	public void testConstructor() {
		ExtendedBoolean eb;
		
		eb= ExtendedBoolean.valueOf(LogicValue.True);
		assertTrue(eb.isSatisfied());
		assertFalse(eb.isUnsatisfied());
		assertFalse(eb.isMaybe());
		eb = ExtendedBoolean.valueOf(LogicValue.False);
		assertFalse(eb.isSatisfied());
		assertTrue(eb.isUnsatisfied());
		assertFalse(eb.isMaybe());
		eb = ExtendedBoolean.valueOf(LogicValue.Maybe);
		assertFalse(eb.isSatisfied());
		assertFalse(eb.isUnsatisfied());
		assertTrue(eb.isMaybe());
	}
	@Test
	public void testAnd() {
		ExtendedBoolean trueEB = ExtendedBoolean.valueOf(LogicValue.True);
		ExtendedBoolean falseEB = ExtendedBoolean.valueOf(LogicValue.False);
		ExtendedBoolean maybeEB = ExtendedBoolean.valueOf(LogicValue.Maybe);
		
		ExtendedBoolean eb;
		// True && True
		eb = trueEB.and(trueEB);
		assertTrue(eb.isSatisfied());
		// True && False
		eb = trueEB.and(falseEB);
		assertTrue(eb.isUnsatisfied());
		// True && Maybe
		eb = trueEB.and(maybeEB);
		assertTrue(eb.isMaybe());
		// False && True
		eb = falseEB.and(trueEB);
		assertTrue(eb.isUnsatisfied());
		// False && False
		eb = falseEB.and(falseEB);
		assertTrue(eb.isUnsatisfied());
		// False && Maybe
		eb = falseEB.and(maybeEB);
		assertTrue(eb.isUnsatisfied());
		// Maybe && True
		eb = maybeEB.and(trueEB);
		assertTrue(eb.isMaybe());
		// Maybe && False
		eb = maybeEB.and(falseEB);
		assertTrue(eb.isUnsatisfied());
		// Maybe && Maybe
		eb = maybeEB.and(maybeEB);
		assertTrue(eb.isMaybe());
	}
	
	@Test
	public void testOr() {
		ExtendedBoolean trueEB = ExtendedBoolean.valueOf(LogicValue.True);
		ExtendedBoolean falseEB = ExtendedBoolean.valueOf(LogicValue.False);
		ExtendedBoolean maybeEB = ExtendedBoolean.valueOf(LogicValue.Maybe);
		
		ExtendedBoolean eb;
		// True || True
		eb = trueEB.or(trueEB);
		assertTrue(eb.isSatisfied());
		// True || False
		eb = trueEB.or(falseEB);
		assertTrue(eb.isSatisfied());
		// True || Maybe
		eb = trueEB.or(maybeEB);
		assertTrue(eb.isSatisfied());
		// False || True
		eb = falseEB.or(trueEB);
		assertTrue(eb.isSatisfied());
		// False && False
		eb = falseEB.or(falseEB);
		assertTrue(eb.isUnsatisfied());
		// False || Maybe
		eb = falseEB.or(maybeEB);
		assertTrue(eb.isMaybe());
		// Maybe || True
		eb = maybeEB.or(trueEB);
		assertTrue(eb.isSatisfied());
		// Maybe || False
		eb = maybeEB.or(falseEB);
		assertTrue(eb.isMaybe());
		// Maybe && Maybe
		eb = maybeEB.or(maybeEB);
		assertTrue(eb.isMaybe());
	}
	
	@Test
	public void testNot() {
		ExtendedBoolean trueEB = ExtendedBoolean.valueOf(LogicValue.True);
		ExtendedBoolean falseEB = ExtendedBoolean.valueOf(LogicValue.False);
		ExtendedBoolean maybeEB = ExtendedBoolean.valueOf(LogicValue.Maybe);
		
		ExtendedBoolean eb;
		// !True
		eb = trueEB.not();
		assertTrue(eb.isUnsatisfied());
		// !False
		eb = falseEB.not();
		assertTrue(eb.isSatisfied());
		// !Maybe
		eb = maybeEB.not();
		assertTrue(eb.isMaybe());
	}
}
