package tauzaman.junit;

import static org.junit.Assert.*;

import org.junit.Test;

import tauzaman.pmf.*;

public class TestPMF {
	@Test
	public void testPrecision_Coarseness() {
		ProbabilityMassFunction pmf;
		float[] massFunction = {1, 1, 1, 1, 1, 1, 1, 1};
		
		pmf = ProbabilityMassFunction.getPMF(1, massFunction);
		assertEquals(1, pmf.getMaxPrecision());
		assertEquals(1, pmf.getMaxCoarseness());
		pmf = ProbabilityMassFunction.getPMF(2, massFunction);
		assertEquals(2, pmf.getMaxPrecision());
		assertEquals(4, pmf.getMaxCoarseness());
		pmf = ProbabilityMassFunction.getPMF(4, massFunction);
		assertEquals(4, pmf.getMaxPrecision());
		assertEquals(16, pmf.getMaxCoarseness());
		pmf = ProbabilityMassFunction.getPMF(10, massFunction);
		assertEquals(10, pmf.getMaxPrecision());
		assertEquals(128, pmf.getMaxCoarseness());
	}
	@Test
	public void testBuildTree() {
		ProbabilityMassFunction pmf;
		float[] massFunction = {1, 2, 4, 5, 5, 4, 2, 1};
		pmf = ProbabilityMassFunction.getPMF(4, massFunction);
		
		// Get Precision
		assertEquals(0, pmf.getPrecision(0));
		assertEquals(0, pmf.getPrecision(1));
		assertEquals(0, pmf.getPrecision(2));
		assertEquals(0, pmf.getPrecision(3));
		assertEquals(0, pmf.getPrecision(4));
		assertEquals(1, pmf.getPrecision(5));
		assertEquals(1, pmf.getPrecision(6));
		assertEquals(1, pmf.getPrecision(7));
		assertEquals(2, pmf.getPrecision(8));
		assertEquals(2, pmf.getPrecision(9));
		assertEquals(3, pmf.getPrecision(10));
		assertEquals(3, pmf.getPrecision(11));
		assertEquals(3, pmf.getPrecision(12));
		assertEquals(3, pmf.getPrecision(13));
		assertEquals(3, pmf.getPrecision(14));
		assertEquals(3, pmf.getPrecision(15));
		
		//Get Coarseness
		assertEquals(4, pmf.getCoarseness(0));
		assertEquals(7, pmf.getCoarseness(1));
		assertEquals(9, pmf.getCoarseness(2));
		assertEquals(15, pmf.getCoarseness(3));
	}
}
