package tauzaman.tests;

import java.io.*;
import java.net.*;

/* use unix style directory delimiters */
public class UpdateSpecFiles {

    private static String absolutePath = null;
    private static String inPath = null;
    private static String absoluteClassPath = null;

    public static void main(String args[]) throws Exception {
    	
    	// Code removed 3/31/09 (should no longer used)
    	System.exit(0);

        if (args.length != 3) {
            System.out.println("usage: java UpdateSpecFiles <absolute path of tauzaman> <absolute class path of tauzaman>");
            System.out.println("note: use unix style directory delimiters");
            System.exit(1);
        }

        absolutePath = args[1];
        inPath = args[0];
        absoluteClassPath = args[2];
        System.out.println("path is " + absolutePath);

        /* Fix path for windows systems */
        absolutePath = absolutePath.replace('\\', '/');
        absoluteClassPath = absoluteClassPath.replace('\\', '/');

        if (absolutePath.lastIndexOf('/') == (absolutePath.length() - 1)) {
            absolutePath = absolutePath.substring(0, absolutePath.length() - 1);
        }
        if (absoluteClassPath.lastIndexOf('/') == (absoluteClassPath.length() - 1)) {
            absoluteClassPath = absoluteClassPath.substring(0, absoluteClassPath.length() - 1);
        }
        
        try {
        URL u = new URL(absolutePath);
        absolutePath = u.toExternalForm();
        
        u = new URL(absoluteClassPath);
        absoluteClassPath = u.toExternalForm(); 
        } catch (MalformedURLException e) {
            System.out.println("Bad URL given either " + absolutePath + " or " + absoluteClassPath);
            System.exit(-1);
        }

        String fileContent = readFile("/iotests/files/base/propertyTable7base.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute path goes here...\\E", absolutePath),
                "/iotests/files/propertyTable7.xml");
        fileContent = readFile("/iotests/files/propertyTable7.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute class goes here...\\E", absoluteClassPath),
                "/iotests/files/propertyTable7.xml");

        fileContent = readFile("/iotests/files/base/propertyTable8base.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute path goes here...\\E", absolutePath),
                "/iotests/files/propertyTable8.xml");
        fileContent = readFile("/iotests/files/propertyTable8.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute class goes here...\\E", absoluteClassPath),
                "/iotests/files/propertyTable8.xml");

        fileContent = readFile("/iotests/files/base/propertyTable1base.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute path goes here...\\E", absolutePath),
                "/iotests/files/propertyTable1.xml");
        fileContent = readFile("/iotests/files/propertyTable1.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute class goes here...\\E", absoluteClassPath),
                "/iotests/files/propertyTable1.xml");

        fileContent = readFile("/iotests/files/base/UofALimitedCalendricSystembase.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute path goes here...\\E", absolutePath),
                "/iotests/files/UofALimitedCalendricSystem.xml");
        fileContent = readFile("/iotests/files/UofALimitedCalendricSystem.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute class goes here...\\E", absoluteClassPath),
                "/iotests/files/UofALimitedCalendricSystem.xml");

        fileContent = readFile("/iotests/files/base/UofACalendarbase.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute path goes here...\\E", absolutePath),
                "/iotests/files/UofACalendar.xml");
        fileContent = readFile("/iotests/files/UofACalendar.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute class goes here...\\E", absoluteClassPath),
                "/iotests/files/UofACalendar.xml");

        fileContent = readFile("/iotests/files/base/ADGregorianCalendarbase.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute path goes here...\\E", absolutePath),
                "/iotests/files/ADGregorianCalendar.xml");
        fileContent = readFile("/iotests/files/ADGregorianCalendar.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute class goes here...\\E", absoluteClassPath),
                "/iotests/files/ADGregorianCalendar.xml");

        fileContent = readFile("/iotests/files/base/Makefilebase");
        writeFile(fileContent.replaceAll("\\Q...absolute path goes here...\\E", absolutePath),
                "/iotests/Makefile");
        fileContent = readFile("/iotests/files/Makefile");
        writeFile(fileContent.replaceAll("\\Q...absolute class goes here...\\E", absoluteClassPath),
                "/iotests/Makefile");

        fileContent = readFile("/application/base/Makefilebase");
        writeFile(fileContent.replaceAll("\\Q...absolute path goes here...\\E", absolutePath),
                "/application/Makefile");
        fileContent = readFile("/application/Makefile");
        writeFile(fileContent.replaceAll("\\Q...absolute class goes here...\\E", absoluteClassPath),
                "/application/Makefile");

        fileContent = readFile("/iotests/files/base/testBasebase.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute path goes here...\\E", absolutePath),
                "/iotests/testBase.xml");
        fileContent = readFile("/iotests/testBase.xml");
        writeFile(fileContent.replaceAll("\\Q...absolute class goes here...\\E", absoluteClassPath),
                "/iotests/testBase.xml");
    }

    private static String readFile(String fileName) throws Exception {

        BufferedReader input = new BufferedReader(
                new InputStreamReader(
                new FileInputStream(inPath + fileName)));

        StringBuffer buffer = new StringBuffer();
        String line;

        while ((line = input.readLine()) != null) {
            buffer.append(line + "\n");
        }

        input.close();

        buffer = buffer.deleteCharAt(buffer.length() - 1);

        return buffer.toString();
    }

    private static void writeFile(String outputStr, String fileName) throws Exception {

        BufferedWriter output = new BufferedWriter(
                new OutputStreamWriter(
                new FileOutputStream(inPath + fileName)));

        output.write(outputStr, 0, outputStr.length());

        output.flush();
        output.close();
    }
}
